# Add rows

Inserts one or more rows into the sheet specified in the URL. If you want to insert the rows in any position but the default, use location-specifier attributes (that is, toTop, toBottom, parentId, siblingId, above, indent, outdent). See language tabs for variations in syntax.

Note: This operation does not add rows with cells that have images. However, you can upload an image to a cell after the cell exists in a sheet. To do so, call the operation described in the Add Image to Cell page.

This operation supports both single-object and bulk semantics. For more information, see Optional Bulk Operations.

Endpoint: POST /sheets/{sheetId}/rows
Version: 2.0.0
Security: APIToken, OAuth2

## Path parameters:

  - `sheetId` (number, required)
    ID of the sheet being accessed.

## Header parameters:

  - `Authorization` (string)
    API Access Token used to authenticate requests to Smartsheet APIs.

  - `smartsheet-integration-source` (string)
    Uses the following metadata to distinguish between human-initiated API requests and third-party service-initiated calls by AI Connectors or ITSM:

- Integration source type
- Organization name
- Integration source name 

Format:


TYPE,OrgName,SourceName


Examples: 

AI,SampleOrg,My-AI-Connector-v2

SCRIPT,SampleOrg2,Accounting-updater-script

APPLICATION,SampleOrg3,SheetUpdater
    Example: "AI,SampleOrg,My-AI-Connector-v2"

  - `Content-Type` (string)
    Required for POST and PUT requests. Defines the structure for the request body.

## Query parameters:

  - `accessApiLevel` (number)
    Allows COMMENTER access for inputs and return values. For backwards-compatibility, VIEWER is the default. For example, to see whether a user has COMMENTER access for a sheet, use accessApiLevel=1.

  - `allowPartialSuccess` (boolean)
    When specified with a value of true, enables partial success for this bulk operation. See Bulk operations > Partial success for more information.

  - `overrideValidation` (boolean)
    You may use the query string parameter overrideValidation with a value of true to allow a cell value outside of the validation limits. You must specify strict with a value of false to bypass value type checking.

## Request fields (application/json):

  - `body` (Row (object) or Array of Row array (objects)) — one of:
    - Row:
      - `id` (number)
        Row ID.
      - `siblingId` (number)
        Sibling ID.
      - `accessLevel` (string)
        Enum: "ADMIN", "COMMENTER", "EDITOR", "EDITOR_SHARE", "OWNER", "VIEWER"
      - `attachments` (array)
        Attachments on row. Only returned if the include query string parameter contains attachments.
      - `attachments.id` (number)
        Attachment ID.
      - `attachments.parentId` (number)
        The ID of the parent.
      - `attachments.attachmentType` (string)
        Attachment type. Note--Dropbox, Egnyte, and Evernote are not supported for Smartsheet.gov accounts.
        Enum: "BOX_COM", "DROPBOX", "EGNYTE", "EVERNOTE", "FILE", "GOOGLE_DRIVE", "LINK", "ONEDRIVE", "TRELLO"
      - `attachments.attachmentSubType` (string)
        Attachment sub type. Note--Folder type is for EGNYTE values and the rest are GOOGLE_DRIVE values.
        Enum: "DOCUMENT", "DRAWING", "FOLDER", "PDF", "PRESENTATION", "SPREADSHEET"
      - `attachments.mimeType` (string)
        Attachment MIME type.
        Example: "PNG"
      - `attachments.parentType` (string)
        The type of object the attachment belongs to.
        Enum: "COMMENT", "PROOF", "ROW", "SHEET"
      - `attachments.createdBy` (object)
        User object containing name and email of the user who created this attachment.
      - `attachments.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `attachments.name` (string)
        Attachment name.
      - `attachments.sizeInKb` (number)
        The size of the file, if the attachmentType is FILE.
      - `attachments.url` (string)
        Attachment temporary URL (files only).
      - `attachments.urlExpiresInMillis` (number)
        Attachment temporary URL time to live (files only).
      - `cells` (array)
        Cells belonging to the row.
      - `cells.columnId` (number)
        The ID of the column that the cell is located in.
      - `cells.columnType` (string)
        Only returned if the include query string parameter contains columnType.
      - `cells.conditionalFormat` (string)
        The format descriptor describing this cell's conditional format. Only returned if the include query string parameter contains format and this cell has a conditional format applied.
      - `cells.displayValue` (string)
        Visual representation of cell contents, as presented to the user in the UI.
      - `cells.format` (string)
        The format descriptor. Only returned if the include query string parameter contains format and this cell has a non-default format applied.
      - `cells.formula` (string)
        The formula for a cell, if set, for instance =COUNTM([Assigned To]3). Note that calculation errors or problems with a formula do not cause the API call to return an error code. Instead, the response contains the same value as in the UI, such as cell.value = "#CIRCULAR REFERENCE".
      - `cells.hyperlink` (object)
      - `cells.hyperlink.reportId` (number)
        If non-null, this hyperlink is a link to the report with this ID.
      - `cells.hyperlink.sheetId` (number)
        If non-null, this hyperlink is a link to the sheet with this ID.
      - `cells.hyperlink.sightId` (number)
        If non-null, this hyperlink is a link to the dashboard with this ID.
      - `cells.hyperlink.url` (string)
        When the hyperlink is a URL link, this property contains the URL value. When the hyperlink is a dashboard/report/sheet link (that is, dashboardId, reportId, or sheetId is non-null), this property contains the permalink to the dashboard, report, or sheet.
      - `cells.image` (object)
      - `cells.image.altText` (string)
        Alternate text for the image.
      - `cells.image.height` (number)
        Original height (in pixels) of the uploaded image.
      - `cells.image.id` (string)
        Image ID.
      - `cells.image.width` (number)
        Original width (in pixels) of the uploaded image.
      - `cells.linkInFromCell` (object)
      - `cells.linkInFromCell.columnId` (number)
        Column ID of the linked cell.
      - `cells.linkInFromCell.rowId` (number)
        Row ID of the linked cell.
      - `cells.linkInFromCell.sheetId` (number)
        Sheet ID of the sheet that the linked cell belongs to.
      - `cells.linkInFromCell.sheetName` (string)
        Sheet name of the linked cell.
      - `cells.linkInFromCell.status` (string)
        * BLOCKED One of several other values indicating unusual error conditions.
* BROKEN The row or sheet linked to was deleted.
* CIRCULAR One of several other values indicating unusual error conditions.
* DISABLED One of several other values indicating unusual error conditions.
* INACCESSIBLE The sheet linked to cannot be viewed by this user.
* INVALID One of several other values indicating unusual error conditions.
* NOT_SHARED One of several other values indicating unusual error conditions.
* OK The link is in a good state.
        Enum: "BLOCKED", "BROKEN", "CIRCULAR", "DISABLED", "INACCESSIBLE", "INVALID", "NOT_SHARED", "OK"
      - `cells.linksOutToCells` (array)
      - `cells.objectValue` (any) — one of:
        - Abstract datetime object value:
          - `objectType` (string)
            Enum: "ABSTRACT_DATETIME"
          - `value` (string)
            Datetime, in the date-time format defined by RFC 3339, section 5.6
        - Contact object value:
          - `objectType` (string)
            Enum: "CONTACT"
          - `email` (string)
            Email address of the Contact
            Example: "john.doe@acme.com"
          - `name` (string)
            Name of the Contact
            Example: "John Doe"
          - `imageId` (string)
            ID of an image associated with the Contact
            Example: "1234!_qwer!_5667zxcvQWER!_ASDF"
          - `emailId` (string)
            ID of the email address
            Example: "23456789"
          - `userId` (string)
            User ID of the contact
            Example: "12345678"
          - `lookUpName` (boolean)
            Whether or not to look up the contact's name based on their email address.
            Example: true
        - Date object value:
          - `objectType` (string)
            Enum: "DATE"
          - `value` (string)
            Date in the full-date format defined by RFC 3339, section 5.6
        - Datetime object value:
          - `objectType` (string)
            Enum: "DATETIME"
          - `value` (string)
            Datetime, in the date-time format defined by RFC 3339, section 5.6
        - Duration object value:
          - `objectType` (string)
            Enum: "DURATION"
          - `days` (number)
            Number of days
        - Multi-contact object value:
          - `objectType` (string)
            Enum: "MULTI_CONTACT"
          - `value` (array)
            List of Contacts
          - `value.objectType` (string)
            Enum: same as `objectType` in "Contact object value" (1 values)
          - `value.email` (string)
            Email address of the Contact
            Example: "john.doe@acme.com"
          - `value.name` (string)
            Name of the Contact
            Example: "John Doe"
          - `value.imageId` (string)
            ID of an image associated with the Contact
            Example: "1234!_qwer!_5667zxcvQWER!_ASDF"
          - `value.emailId` (string)
            ID of the email address
            Example: "23456789"
          - `value.userId` (string)
            User ID of the contact
            Example: "12345678"
          - `value.lookUpName` (boolean)
            Whether or not to look up the contact's name based on their email address.
            Example: true
        - Multi-picklist object value:
          - `objectType` (string)
            Enum: "MULTI_PICKLIST"
          - `values` (array)
            List of strings to choose from
        - Predecessor list object value:
          - `objectType` (string)
            Enum: "PREDECESSOR_LIST"
          - `predecessors` (array)
            List of references to rows on which the current row depends
            Example: [{"rowId":1234567890123456,"rowNumber":2,"type":"FS","inCriticalPath":true}]
          - `predecessors.rowId` (number)
            The ID of the predecessor row.
            Example: 1234567890123456
          - `predecessors.type` (string)
            Type of the predecessor:
 * FF (Finish-to-Finish) - finish at the same time the predecessor finishes.
 * FS (Finish-to-Start) - start after the predecessor finishes.
 * SF (Start-to-Finish) - finish before the predecessor starts.
 * SS (Start-to-Start) - start at the same time the predecessor starts.
            Enum: "FF", "FS", "SF", "SS"
          - `predecessors.lag` (object)
            In a project sheet, represents a value in a duration cell, or a lag value of a predecessor.
          - `predecessors.lag.days` (number)
            The number of days for this duration.
          - `predecessors.lag.elapsed` (boolean)
            If true, indicates this duration represents elapsed time, which ignores non-working time.
          - `predecessors.lag.hours` (number)
            The number of hours for this duration.
          - `predecessors.lag.milliseconds` (number)
            The number of milliseconds for this duration.
          - `predecessors.lag.minutes` (number)
            The number of minutes for this duration.
          - `predecessors.lag.negative` (boolean)
            When used as a predecessor's lag value, indicates whether the lag is negative (if true), or positive (false). The individual duration values themselves (for example, days, hours, or minutes) is always positive.
          - `predecessors.lag.objectType` (string)
            Enum: same as `objectType` in "Duration object value" (1 values)
          - `predecessors.lag.seconds` (number)
            The number of seconds for this duration.
          - `predecessors.lag.weeks` (number)
            The number of weeks for this duration.
      - `cells.overrideValidation` (boolean)
        (Admin only) Indicates whether the cell value can contain a value outside of the validation limits (value = true). When using this parameter, you must also set strict to false to bypass value type checking. This property is honored for POST or PUT actions that update rows.
      - `cells.strict` (boolean)
        Set to false to enable lenient parsing. Defaults to true. You can specify this attribute in a request, but it is never present in a response.
      - `cells.value` (any)
        A string, number, or a Boolean value -- depending on the cell type and the data in the cell. Cell values larger than 4000 characters are silently truncated. An empty cell returns no value.
      - `columns` (array) — one of:
        Columns of row. Only returned if the include query string parameter contains columns.
        - Text/number column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            The formula for the column, if set.

For example: =[Column A]@row + [Column B]@row
          - `primary` (boolean)
            If set to true, the column is the sheet's Primary Column. This property is returned only if the property is set to true.
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: "TEXT_NUMBER"
        - Auto number column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `autoNumberFormat` (object, required)
            Specifies how to format values for an auto-generated numbers column.
            Example: {"fill":"","prefix":"","startingNumber":1,"suffix":""}
          - `autoNumberFormat.fill` (string)
            Indicates zero-padding. It must be between 0 and 10 "0" (zero) characters.
          - `autoNumberFormat.prefix` (string)
            The prefix. Can include these date tokens:
  * {DD}
  * {MM}
  * {YY}
  * {YYYY}
          - `autoNumberFormat.startingNumber` (number)
            The starting number for the auto-ID.
            Example: 1
          - `autoNumberFormat.suffix` (string)
            The suffix. Can include these date tokens:
  * {DD}
  * {MM}
  * {YY}
  * {YYYY}
          - `systemColumnType` (string, required)
            If this property is set, the column contains auto-generated numbers. Its [Auto-number format object](/api/smartsheet/openapi/schemas/autonumberformat) describes the mask used to generate column values.
            Enum: "AUTO_NUMBER"
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Text/number column" (1 values)
        - Checkbox column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            The formula for the column, if set.

For example: "=ISODD([ID]@row)"
          - `symbol` (string)
            A checkbox column can use box (default), flag, or star symbols. See [Symbol Columns](/api/smartsheet/openapi/columns).

If the box symbol is used, the symbol property is absent.
            Enum: "FLAG", "STAR"
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: "CHECKBOX"
        - Contact list column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `contactOptions` (array)
            Array of ContactOption objects to specify a pre-defined list of values for the column.
            Example: [{"email":"jane.doe@smartsheet.com","name":"Jane Doe"},{"email":"john.doe@company.com","name":"John Doe"}]
          - `contactOptions.email` (string)
            A parsable email address.
          - `contactOptions.name` (string)
            Can be a user's name, display name, or free text.
          - `formula` (string)
            The formula for the column, if set.

For example: =IF(Department@row = "Engineering", "jane.doe@company.com", IF(Department@row = "Marketing", "john.smith@company.com", "admin@company.com"))
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: "CONTACT_LIST"
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
        - Created by column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `systemColumnType` (string, required)
            The contact represents the user who created the row.
            Enum: "CREATED_BY"
          - `type` (string, required)
            Enum: same as `type` in "Contact list column" (1 values)
        - Created date column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `systemColumnType` (string, required)
            The system row creation datetime type.
            Enum: "CREATED_DATE"
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Datetime object value" (1 values)
        - Date column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            The formula for the column, if set.

For example: =TODAY(-1)
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Date object value" (1 values)
        - Abstract datetime column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            The formula for the column, if set.

For example: =TODAY(-1)
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Abstract datetime object value" (1 values)
        - Dropdown list column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            A formula that returns a string value that matches one of the symbol options exactly (for example, "Red", "Yellow", "Green").

For example: =[Literal Rating]@row
          - `options` (array, required)
            An array of the options available to use in the column.
            Example: ["Option 1","Option 2","Option n"]
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: "PICKLIST"
        - Duration column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Duration object value" (1 values)
        - Modified by column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `systemColumnType` (string, required)
            If specified, the contact represents the user who created the row or last modified it.
            Enum: "MODIFIED_BY"
          - `type` (string, required)
            Enum: same as `type` in "Contact list column" (1 values)
        - Modified date column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `systemColumnType` (string, required)
            The system row modification datetime type.
            Enum: "MODIFIED_DATE"
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Datetime object value" (1 values)
        - Multi-contact list column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `contactOptions` (array)
            Array of ContactOption objects to specify a pre-defined list of values for the column.
            Example: [{"email":"jane.doe@smartsheet.com","name":"Jane Doe"},{"email":"john.doe@company.com","name":"John Doe"}]
          - `contactOptions.email` (string)
            A parsable email address.
          - `contactOptions.name` (string)
            Can be a user's name, display name, or free text.
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: "MULTI_CONTACT_LIST"
        - Multi-dropdown list column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            A formula that returns a string value that matches a combination of the symbol options exactly, and include new line separators between multiple values.

For example: =JOIN(Range1@row:Range3@row, CHAR(10))

Important: To match multiple symbol option values, the return string must use a new line separator (that is, CHAR(10)) between symbol option values.
          - `options` (array, required)
            An array of the options available to use in the column. A cell value in this column can contain any number of these options.
            Example: ["Option 1","Option 2","Option n"]
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Multi-picklist object value" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
        - Percent complete column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Text/number column" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
            Example: true
        - Predecessor column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: "PREDECESSOR"
        - Assigned resource contact column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `options` (array, required)
            An array of contacts available to use in the column. A cell value in this column can contain one contact.
            Example: ["jane.doe@smartsheet.com","firstname.lastname@smartsheet.com"]
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Contact list column" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
            Example: true
        - Assigned resource text column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `primary` (boolean)
            Returned only if the column is the Primary Column (value = true).
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Text/number column" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
            Example: true
        - Percent allocation column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Text/number column" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
            Example: true
        - Symbol column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            A formula that returns a string value that matches one of the symbol options exactly (for example, "Red", "Yellow", "Green").

For example: =[Literal Rating]@row
          - `options` (array, required)
            An array of the options available to use in the column.

Note: All applicable options values are set automatically when you specify the symbol.

Important: You can't specify or update options at the same time you're specifying symbol. So leave it unspecified when you're creating a column or updating its symbol. If needed, you can update options in a separate call.
            Example: []
          - `symbol` (string)
            Specifies any type of symbol the column uses. For details and examples, see [Symbol Columns](/api/smartsheet/openapi/columns).
            Enum: "FLAG", "STAR", "HARVEY_BALLS", "PRIORITY", "RYG", "PRIORITY_HML", "DECISION_SYMBOLS", "DECISION_SHAPES", "VCR", "RYGB", "RYGG", "WEATHER", "PROGRESS", "ARROWS_3_WAY", "ARROWS_4_WAY", "ARROWS_5_WAY", "DIRECTIONS_3_WAY", "DIRECTIONS_4_WAY", "SKI", "SIGNAL", "STAR_RATING", "HEARTS", "MONEY", "EFFORT", "PAIN"
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Dropdown list column" (1 values)
      - `conditionalFormat` (string)
        Describes this row's conditional format. Only returned if the include query string parameter contains format and this row has a conditional format applied.
        Example: ",,1,1,,,,,,,,,,,,,"
      - `createdBy` (object)
        User object containing name and email of the creator of this row.
      - `createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions` (array)
        Discussions on the row. Only returned if the include query string parameter contains discussions.
      - `discussions.accessLevel` (string)
        Enum: same as `accessLevel` in "Row" (6 values)
      - `discussions.id` (number)
        Discussion ID.
      - `discussions.comments` (array)
        Array of comments in discussion. Only returned if the include query string parameter contains comments.
      - `discussions.comments.attachments` (array)
        Array of attachments on comments.
      - `discussions.comments.createdBy` (object)
        User object containing name and email of the creator of this comment.
      - `discussions.comments.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.comments.discussionId` (number)
        Discussion ID of discussion that contains comment.
      - `discussions.comments.id` (number)
        Comment ID.
      - `discussions.comments.text` (string)
        Comment body.
      - `discussions.commentAttachments` (array)
        Array of attachments on discussion comments. Only returned if the include query string parameter contains attachments.
      - `discussions.commentCount` (number)
        Number of comments in the discussion.
      - `discussions.createdBy` (object)
        User object containing name and email of the user who created the discussion.
      - `discussions.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.lastCommentedUser` (object)
        User object containing name and email of the user who last commented on the discussion.
      - `discussions.lastCommentedUser.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.parentId` (number)
        The ID of the associated row or sheet.
      - `discussions.parentType` (string)
        Type of parent object.
        Enum: "ROW", "SHEET"
      - `discussions.readOnly` (boolean)
        Indicates whether the user can modify the discussion.
      - `proof` (object)
        Object containing zero or more media items, including images, videos, and documents, for review, editing, or approval.
      - `proof.id` (number)
        Proof ID of the proof version.
      - `proof.originalId` (number)
        Proof ID of the original proof version.
      - `proof.name` (string)
        Proof name. This is the same as primary column value. If the primary column value is empty, name is empty.
      - `proof.type` (string)
        File type for the proof version.
        Enum: "DOCUMENT", "IMAGE", "MIXED", "NONE", "VIDEO"
      - `proof.documentType` (string)
        If type=DOCUMENT, then this indicates the type of file, such as PDF.
      - `proof.proofRequestUrl` (string)
        URL to review a proofing request.
      - `proof.version` (number)
        The version number of the proof.
      - `proof.lastUpdatedBy` (object)
        User object containing name and email of the user who last updated the proof.
      - `proof.lastUpdatedBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `proof.isCompleted` (boolean)
        Indicates whether the proof is completed.
      - `proof.attachments` (array)
        Array of Attachment objects. Only returned if the include query string parameter contains attachments.
      - `proof.discussions` (array)
        Array of Discussion objects. Only returned if the include query string parameter contains discussions.
      - `expanded` (boolean)
        Indicates whether the row is expanded or collapsed.
      - `filteredOut` (boolean)
        Indicates if the row is filtered out by a column filter. Only returned if the include query string parameter contains filters.
      - `format` (string)
        Format descriptor. Only returned if the include query string parameter contains format and this row has a non-default format applied.
        Example: ",,1,1,,,,,,,,,,,,,"
      - `inCriticalPath` (boolean)
        Only returned, with a value of true, if the sheet is a project sheet with dependencies enabled and this row is in the critical path.
      - `locked` (boolean)
        Indicates whether the row is locked.
      - `lockedForUser` (boolean)
        Indicates whether the row is locked for the requesting user.
      - `modifiedBy` (object)
        User object containing name and email of the last person to modify this row.
      - `modifiedBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `permaLink` (string)
        URL that represents a direct link to the row in Smartsheet. Only returned if the include query string parameter contains rowPermalink.
      - `rowNumber` (number)
        Row number within the sheet.
      - `version` (number)
        Sheet version number that is incremented every time a sheet is modified.
    - Row array:
      - `id` (number)
        Row ID.
      - `siblingId` (number)
        Sibling ID.
      - `accessLevel` (string)
        Enum: same as `accessLevel` in "Row" (6 values)
      - `attachments` (array)
        Attachments on row. Only returned if the include query string parameter contains attachments.
      - `attachments.id` (number)
        Attachment ID.
      - `attachments.parentId` (number)
        The ID of the parent.
      - `attachments.attachmentType` (string)
        Attachment type. Note--Dropbox, Egnyte, and Evernote are not supported for Smartsheet.gov accounts.
        Enum: same as `attachments.attachmentType` in "Row" (9 values)
      - `attachments.attachmentSubType` (string)
        Attachment sub type. Note--Folder type is for EGNYTE values and the rest are GOOGLE_DRIVE values.
        Enum: same as `attachments.attachmentSubType` in "Row" (6 values)
      - `attachments.mimeType` (string)
        Attachment MIME type.
        Example: "PNG"
      - `attachments.parentType` (string)
        The type of object the attachment belongs to.
        Enum: same as `attachments.parentType` in "Row" (4 values)
      - `attachments.createdBy` (object)
        User object containing name and email of the user who created this attachment.
      - `attachments.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `attachments.name` (string)
        Attachment name.
      - `attachments.sizeInKb` (number)
        The size of the file, if the attachmentType is FILE.
      - `attachments.url` (string)
        Attachment temporary URL (files only).
      - `attachments.urlExpiresInMillis` (number)
        Attachment temporary URL time to live (files only).
      - `cells` (array)
        Cells belonging to the row.
      - `cells.columnId` (number)
        The ID of the column that the cell is located in.
      - `cells.columnType` (string)
        Only returned if the include query string parameter contains columnType.
      - `cells.conditionalFormat` (string)
        The format descriptor describing this cell's conditional format. Only returned if the include query string parameter contains format and this cell has a conditional format applied.
      - `cells.displayValue` (string)
        Visual representation of cell contents, as presented to the user in the UI.
      - `cells.format` (string)
        The format descriptor. Only returned if the include query string parameter contains format and this cell has a non-default format applied.
      - `cells.formula` (string)
        The formula for a cell, if set, for instance =COUNTM([Assigned To]3). Note that calculation errors or problems with a formula do not cause the API call to return an error code. Instead, the response contains the same value as in the UI, such as cell.value = "#CIRCULAR REFERENCE".
      - `cells.hyperlink` (object)
      - `cells.hyperlink.reportId` (number)
        If non-null, this hyperlink is a link to the report with this ID.
      - `cells.hyperlink.sheetId` (number)
        If non-null, this hyperlink is a link to the sheet with this ID.
      - `cells.hyperlink.sightId` (number)
        If non-null, this hyperlink is a link to the dashboard with this ID.
      - `cells.hyperlink.url` (string)
        When the hyperlink is a URL link, this property contains the URL value. When the hyperlink is a dashboard/report/sheet link (that is, dashboardId, reportId, or sheetId is non-null), this property contains the permalink to the dashboard, report, or sheet.
      - `cells.image` (object)
      - `cells.image.altText` (string)
        Alternate text for the image.
      - `cells.image.height` (number)
        Original height (in pixels) of the uploaded image.
      - `cells.image.id` (string)
        Image ID.
      - `cells.image.width` (number)
        Original width (in pixels) of the uploaded image.
      - `cells.linkInFromCell` (object)
      - `cells.linkInFromCell.columnId` (number)
        Column ID of the linked cell.
      - `cells.linkInFromCell.rowId` (number)
        Row ID of the linked cell.
      - `cells.linkInFromCell.sheetId` (number)
        Sheet ID of the sheet that the linked cell belongs to.
      - `cells.linkInFromCell.sheetName` (string)
        Sheet name of the linked cell.
      - `cells.linkInFromCell.status` (string)
        * BLOCKED One of several other values indicating unusual error conditions.
* BROKEN The row or sheet linked to was deleted.
* CIRCULAR One of several other values indicating unusual error conditions.
* DISABLED One of several other values indicating unusual error conditions.
* INACCESSIBLE The sheet linked to cannot be viewed by this user.
* INVALID One of several other values indicating unusual error conditions.
* NOT_SHARED One of several other values indicating unusual error conditions.
* OK The link is in a good state.
        Enum: same as `cells.linkInFromCell.status` in "Row" (8 values)
      - `cells.linksOutToCells` (array)
      - `cells.objectValue` (any) — one of:
        - Abstract datetime object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Abstract datetime object value" (1 values)
          - `value` (string)
            Datetime, in the date-time format defined by RFC 3339, section 5.6
        - Contact object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Contact object value" (1 values)
          - `email` (string)
            Email address of the Contact
            Example: "john.doe@acme.com"
          - `name` (string)
            Name of the Contact
            Example: "John Doe"
          - `imageId` (string)
            ID of an image associated with the Contact
            Example: "1234!_qwer!_5667zxcvQWER!_ASDF"
          - `emailId` (string)
            ID of the email address
            Example: "23456789"
          - `userId` (string)
            User ID of the contact
            Example: "12345678"
          - `lookUpName` (boolean)
            Whether or not to look up the contact's name based on their email address.
            Example: true
        - Date object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Date object value" (1 values)
          - `value` (string)
            Date in the full-date format defined by RFC 3339, section 5.6
        - Datetime object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Datetime object value" (1 values)
          - `value` (string)
            Datetime, in the date-time format defined by RFC 3339, section 5.6
        - Duration object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Duration object value" (1 values)
          - `days` (number)
            Number of days
        - Multi-contact object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Multi-contact object value" (1 values)
          - `value` (array)
            List of Contacts
          - `value.objectType` (string)
            Enum: same as `objectType` in "Contact object value" (1 values)
          - `value.email` (string)
            Email address of the Contact
            Example: "john.doe@acme.com"
          - `value.name` (string)
            Name of the Contact
            Example: "John Doe"
          - `value.imageId` (string)
            ID of an image associated with the Contact
            Example: "1234!_qwer!_5667zxcvQWER!_ASDF"
          - `value.emailId` (string)
            ID of the email address
            Example: "23456789"
          - `value.userId` (string)
            User ID of the contact
            Example: "12345678"
          - `value.lookUpName` (boolean)
            Whether or not to look up the contact's name based on their email address.
            Example: true
        - Multi-picklist object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Multi-picklist object value" (1 values)
          - `values` (array)
            List of strings to choose from
        - Predecessor list object value:
          - `objectType` (string)
            Enum: same as `objectType` in "Predecessor list object value" (1 values)
          - `predecessors` (array)
            List of references to rows on which the current row depends
            Example: [{"rowId":1234567890123456,"rowNumber":2,"type":"FS","inCriticalPath":true}]
          - `predecessors.rowId` (number)
            The ID of the predecessor row.
            Example: 1234567890123456
          - `predecessors.type` (string)
            Type of the predecessor:
 * FF (Finish-to-Finish) - finish at the same time the predecessor finishes.
 * FS (Finish-to-Start) - start after the predecessor finishes.
 * SF (Start-to-Finish) - finish before the predecessor starts.
 * SS (Start-to-Start) - start at the same time the predecessor starts.
            Enum: same as `predecessors.type` in "Predecessor list object value" (4 values)
          - `predecessors.lag` (object)
            In a project sheet, represents a value in a duration cell, or a lag value of a predecessor.
          - `predecessors.lag.days` (number)
            The number of days for this duration.
          - `predecessors.lag.elapsed` (boolean)
            If true, indicates this duration represents elapsed time, which ignores non-working time.
          - `predecessors.lag.hours` (number)
            The number of hours for this duration.
          - `predecessors.lag.milliseconds` (number)
            The number of milliseconds for this duration.
          - `predecessors.lag.minutes` (number)
            The number of minutes for this duration.
          - `predecessors.lag.negative` (boolean)
            When used as a predecessor's lag value, indicates whether the lag is negative (if true), or positive (false). The individual duration values themselves (for example, days, hours, or minutes) is always positive.
          - `predecessors.lag.objectType` (string)
            Enum: same as `objectType` in "Duration object value" (1 values)
          - `predecessors.lag.seconds` (number)
            The number of seconds for this duration.
          - `predecessors.lag.weeks` (number)
            The number of weeks for this duration.
      - `cells.overrideValidation` (boolean)
        (Admin only) Indicates whether the cell value can contain a value outside of the validation limits (value = true). When using this parameter, you must also set strict to false to bypass value type checking. This property is honored for POST or PUT actions that update rows.
      - `cells.strict` (boolean)
        Set to false to enable lenient parsing. Defaults to true. You can specify this attribute in a request, but it is never present in a response.
      - `cells.value` (any)
        A string, number, or a Boolean value -- depending on the cell type and the data in the cell. Cell values larger than 4000 characters are silently truncated. An empty cell returns no value.
      - `columns` (array) — one of:
        Columns of row. Only returned if the include query string parameter contains columns.
        - Text/number column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            The formula for the column, if set.

For example: =[Column A]@row + [Column B]@row
          - `primary` (boolean)
            If set to true, the column is the sheet's Primary Column. This property is returned only if the property is set to true.
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Text/number column" (1 values)
        - Auto number column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `autoNumberFormat` (object, required)
            Specifies how to format values for an auto-generated numbers column.
            Example: {"fill":"","prefix":"","startingNumber":1,"suffix":""}
          - `autoNumberFormat.fill` (string)
            Indicates zero-padding. It must be between 0 and 10 "0" (zero) characters.
          - `autoNumberFormat.prefix` (string)
            The prefix. Can include these date tokens:
  * {DD}
  * {MM}
  * {YY}
  * {YYYY}
          - `autoNumberFormat.startingNumber` (number)
            The starting number for the auto-ID.
            Example: 1
          - `autoNumberFormat.suffix` (string)
            The suffix. Can include these date tokens:
  * {DD}
  * {MM}
  * {YY}
  * {YYYY}
          - `systemColumnType` (string, required)
            If this property is set, the column contains auto-generated numbers. Its [Auto-number format object](/api/smartsheet/openapi/schemas/autonumberformat) describes the mask used to generate column values.
            Enum: same as `systemColumnType` in "Auto number column" (1 values)
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Text/number column" (1 values)
        - Checkbox column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            The formula for the column, if set.

For example: "=ISODD([ID]@row)"
          - `symbol` (string)
            A checkbox column can use box (default), flag, or star symbols. See [Symbol Columns](/api/smartsheet/openapi/columns).

If the box symbol is used, the symbol property is absent.
            Enum: same as `symbol` in "Checkbox column" (2 values)
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Checkbox column" (1 values)
        - Contact list column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `contactOptions` (array)
            Array of ContactOption objects to specify a pre-defined list of values for the column.
            Example: [{"email":"jane.doe@smartsheet.com","name":"Jane Doe"},{"email":"john.doe@company.com","name":"John Doe"}]
          - `contactOptions.email` (string)
            A parsable email address.
          - `contactOptions.name` (string)
            Can be a user's name, display name, or free text.
          - `formula` (string)
            The formula for the column, if set.

For example: =IF(Department@row = "Engineering", "jane.doe@company.com", IF(Department@row = "Marketing", "john.smith@company.com", "admin@company.com"))
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Contact list column" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
        - Created by column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `systemColumnType` (string, required)
            The contact represents the user who created the row.
            Enum: same as `systemColumnType` in "Created by column" (1 values)
          - `type` (string, required)
            Enum: same as `type` in "Contact list column" (1 values)
        - Created date column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `systemColumnType` (string, required)
            The system row creation datetime type.
            Enum: same as `systemColumnType` in "Created date column" (1 values)
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Datetime object value" (1 values)
        - Date column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            The formula for the column, if set.

For example: =TODAY(-1)
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Date object value" (1 values)
        - Abstract datetime column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            The formula for the column, if set.

For example: =TODAY(-1)
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Abstract datetime object value" (1 values)
        - Dropdown list column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            A formula that returns a string value that matches one of the symbol options exactly (for example, "Red", "Yellow", "Green").

For example: =[Literal Rating]@row
          - `options` (array, required)
            An array of the options available to use in the column.
            Example: ["Option 1","Option 2","Option n"]
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Dropdown list column" (1 values)
        - Duration column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Duration object value" (1 values)
        - Modified by column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `systemColumnType` (string, required)
            If specified, the contact represents the user who created the row or last modified it.
            Enum: same as `systemColumnType` in "Modified by column" (1 values)
          - `type` (string, required)
            Enum: same as `type` in "Contact list column" (1 values)
        - Modified date column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `systemColumnType` (string, required)
            The system row modification datetime type.
            Enum: same as `systemColumnType` in "Modified date column" (1 values)
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Datetime object value" (1 values)
        - Multi-contact list column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `contactOptions` (array)
            Array of ContactOption objects to specify a pre-defined list of values for the column.
            Example: [{"email":"jane.doe@smartsheet.com","name":"Jane Doe"},{"email":"john.doe@company.com","name":"John Doe"}]
          - `contactOptions.email` (string)
            A parsable email address.
          - `contactOptions.name` (string)
            Can be a user's name, display name, or free text.
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Multi-contact list column" (1 values)
        - Multi-dropdown list column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            A formula that returns a string value that matches a combination of the symbol options exactly, and include new line separators between multiple values.

For example: =JOIN(Range1@row:Range3@row, CHAR(10))

Important: To match multiple symbol option values, the return string must use a new line separator (that is, CHAR(10)) between symbol option values.
          - `options` (array, required)
            An array of the options available to use in the column. A cell value in this column can contain any number of these options.
            Example: ["Option 1","Option 2","Option n"]
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `objectType` in "Multi-picklist object value" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
        - Percent complete column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Text/number column" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
            Example: true
        - Predecessor column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Predecessor column" (1 values)
        - Assigned resource contact column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `options` (array, required)
            An array of contacts available to use in the column. A cell value in this column can contain one contact.
            Example: ["jane.doe@smartsheet.com","firstname.lastname@smartsheet.com"]
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Contact list column" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
            Example: true
        - Assigned resource text column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `primary` (boolean)
            Returned only if the column is the Primary Column (value = true).
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Text/number column" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
            Example: true
        - Percent allocation column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Text/number column" (1 values)
          - `validation` (boolean, required)
            If true, validation is enabled for the column values.
            Example: true
        - Symbol column:
          - `description` (string)
            Column description.
          - `format` (string)
            The format descriptor (see [Cell formatting](/api/smartsheet/guides/advanced-topics/cell-formatting)).

Note: It's only returned if the include query string parameter contains format and this column has a non-default format applied to it.
          - `hidden` (boolean)
            If set to true, the column is hidden.
          - `index` (number, required)
            The column's position in the sheet. Indexes start at 0.
          - `locked` (boolean)
            If set to true, the column is locked. Locking a column requires owner or admin permissions on the sheet.
          - `title` (string, required)
            Column title.
          - `width` (number, required)
            The column's display width in pixels.
            Example: 150
          - `formula` (string)
            A formula that returns a string value that matches one of the symbol options exactly (for example, "Red", "Yellow", "Green").

For example: =[Literal Rating]@row
          - `options` (array, required)
            An array of the options available to use in the column.

Note: All applicable options values are set automatically when you specify the symbol.

Important: You can't specify or update options at the same time you're specifying symbol. So leave it unspecified when you're creating a column or updating its symbol. If needed, you can update options in a separate call.
            Example: []
          - `symbol` (string)
            Specifies any type of symbol the column uses. For details and examples, see [Symbol Columns](/api/smartsheet/openapi/columns).
            Enum: same as `symbol` in "Symbol column" (25 values)
          - `type` (string, required)
            The column's type. See [Column Types](/api/smartsheet/openapi/columns).
            Enum: same as `type` in "Dropdown list column" (1 values)
      - `conditionalFormat` (string)
        Describes this row's conditional format. Only returned if the include query string parameter contains format and this row has a conditional format applied.
        Example: ",,1,1,,,,,,,,,,,,,"
      - `createdBy` (object)
        User object containing name and email of the creator of this row.
      - `createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions` (array)
        Discussions on the row. Only returned if the include query string parameter contains discussions.
      - `discussions.accessLevel` (string)
        Enum: same as `accessLevel` in "Row" (6 values)
      - `discussions.id` (number)
        Discussion ID.
      - `discussions.comments` (array)
        Array of comments in discussion. Only returned if the include query string parameter contains comments.
      - `discussions.comments.attachments` (array)
        Array of attachments on comments.
      - `discussions.comments.createdBy` (object)
        User object containing name and email of the creator of this comment.
      - `discussions.comments.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.comments.discussionId` (number)
        Discussion ID of discussion that contains comment.
      - `discussions.comments.id` (number)
        Comment ID.
      - `discussions.comments.text` (string)
        Comment body.
      - `discussions.commentAttachments` (array)
        Array of attachments on discussion comments. Only returned if the include query string parameter contains attachments.
      - `discussions.commentCount` (number)
        Number of comments in the discussion.
      - `discussions.createdBy` (object)
        User object containing name and email of the user who created the discussion.
      - `discussions.createdBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.lastCommentedUser` (object)
        User object containing name and email of the user who last commented on the discussion.
      - `discussions.lastCommentedUser.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `discussions.parentId` (number)
        The ID of the associated row or sheet.
      - `discussions.parentType` (string)
        Type of parent object.
        Enum: same as `discussions.parentType` in "Row" (2 values)
      - `discussions.readOnly` (boolean)
        Indicates whether the user can modify the discussion.
      - `proof` (object)
        Object containing zero or more media items, including images, videos, and documents, for review, editing, or approval.
      - `proof.id` (number)
        Proof ID of the proof version.
      - `proof.originalId` (number)
        Proof ID of the original proof version.
      - `proof.name` (string)
        Proof name. This is the same as primary column value. If the primary column value is empty, name is empty.
      - `proof.type` (string)
        File type for the proof version.
        Enum: same as `proof.type` in "Row" (5 values)
      - `proof.documentType` (string)
        If type=DOCUMENT, then this indicates the type of file, such as PDF.
      - `proof.proofRequestUrl` (string)
        URL to review a proofing request.
      - `proof.version` (number)
        The version number of the proof.
      - `proof.lastUpdatedBy` (object)
        User object containing name and email of the user who last updated the proof.
      - `proof.lastUpdatedBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `proof.isCompleted` (boolean)
        Indicates whether the proof is completed.
      - `proof.attachments` (array)
        Array of Attachment objects. Only returned if the include query string parameter contains attachments.
      - `proof.discussions` (array)
        Array of Discussion objects. Only returned if the include query string parameter contains discussions.
      - `expanded` (boolean)
        Indicates whether the row is expanded or collapsed.
      - `filteredOut` (boolean)
        Indicates if the row is filtered out by a column filter. Only returned if the include query string parameter contains filters.
      - `format` (string)
        Format descriptor. Only returned if the include query string parameter contains format and this row has a non-default format applied.
        Example: ",,1,1,,,,,,,,,,,,,"
      - `inCriticalPath` (boolean)
        Only returned, with a value of true, if the sheet is a project sheet with dependencies enabled and this row is in the critical path.
      - `locked` (boolean)
        Indicates whether the row is locked.
      - `lockedForUser` (boolean)
        Indicates whether the row is locked for the requesting user.
      - `modifiedBy` (object)
        User object containing name and email of the last person to modify this row.
      - `modifiedBy.email` (string)
        Example: "jane.doe@smartsheet.com"
      - `permaLink` (string)
        URL that represents a direct link to the row in Smartsheet. Only returned if the include query string parameter contains rowPermalink.
      - `rowNumber` (number)
        Row number within the sheet.
      - `version` (number)
        Sheet version number that is incremented every time a sheet is modified.

## Response 200 fields (application/json):

  - `message` (string)
    Message that indicates the outcome of the request. (One of SUCCESS or PARTIAL_SUCCESS.)
    Enum: "PARTIAL_SUCCESS", "SUCCESS"

  - `resultCode` (number)
    * '0' Success
* '3' Partial Success of Bulk Operation
    Enum: 0, 3

  - `result` (array)

  - `result.id` (number)
    Row ID.

  - `result.sheetId` (number)
    Parent sheet ID.

  - `result.rowNumber` (number)
    Row number within the sheet.

  - `result.expanded` (boolean)
    Indicates whether the row is expanded or collapsed.

  - `result.createdAt` (any)

  - `result.modifiedAt` (any)

  - `result.cells` (array)
    Cells objects.

  - `result.cells.columnId` (number)
    The ID of the column that the cell is located in.

  - `result.cells.columnType` (string)
    Only returned if the include query string parameter contains columnType.

  - `result.cells.value` (any)
    A string, number, or a Boolean value -- depending on the cell type and the data in the cell. Cell values larger than 4000 characters are silently truncated. An empty cell returns no value.

  - `result.cells.displayValue` (string)
    Visual representation of cell contents, as presented to the user in the UI.

  - `result.version` (number)
    Sheet version number that is incremented every time a sheet is modified.

## Response default fields (application/json):

  - `refId` (string)
    The ID of the specific error occurrence. Please include this information when contacting Smartsheet support.

  - `errorCode` (number)
    Custom error code from Smartsheet. See the complete [Error Code List](/api/smartsheet/error-codes).

  - `message` (string)
    Descriptive error message.


